<?php

/*********************************************************************

 スケジュールレスポンスdisplayプラグイン (2015/09/09)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

//外部ファイル読み込み
require_once FREO_MAIN_DIR . 'freo/plugins/security_plugin_scheduleres.php';

/* メイン処理 */
function freo_display_scheduleres()
{
	global $freo;

	//パラメータ検証
	if (!isset($_GET['schedule_id']) and isset($freo->parameters[2])) {
		$_GET['schedule_id'] = $freo->parameters[2];
	}

	//検索条件設定
	$ascending = false;
	if ($freo->config['plugin']['scheduleres']['scheduleres_order'] == 'ascend') {
		$ascending = true;
	}
	if ($ascending == true) {
		$order = ' id';
	} else {
		$order = ' id DESC';
	}

	//スケジュールレスポンス取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_schedulereses WHERE schedule_id = :schedule_id ORDER BY' . $order);
	$stmt->bindValue(':schedule_id', $_GET['schedule_id']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_schedulereses = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_schedulereses[$data['id']] = $data;
	}

	//スケジュールレスポンスID取得
	$plugin_scheduleres_keys = array_keys($plugin_schedulereses);

	//スケジュールレスポンス保護データ取得
	$plugin_scheduleres_securities = freo_security_plugin_scheduleres('user', $plugin_scheduleres_keys);

	foreach ($plugin_scheduleres_securities as $id => $security) {
		if (!$security) {
			continue;
		}

		$plugin_schedulereses[$id]['name']      = $freo->config['plugin']['scheduleres']['restriction_name'];
		$plugin_schedulereses[$id]['mail']      = null;
		$plugin_schedulereses[$id]['url']       = null;
		$plugin_schedulereses[$id]['text']      = $freo->config['plugin']['scheduleres']['restriction_text'];

	}

	//スケジュール全件取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_schedules');
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_schedule_alls = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_schedule_alls[$data['id']] = $data;
	}

	//スケジュールID取得
	$plugin_schedule_all_keys = array_keys($plugin_schedule_alls);

	//データ初期化
	$scheduleres_counts = array();
	foreach ($plugin_schedule_all_keys as $plugin_schedule_all) {
		$scheduleres_counts[$plugin_schedule_all] = 1;
	}

	//スケジュールごとのスケジュールレスポンス数取得
	$stmt = $freo->pdo->query('SELECT schedule_id, COUNT(*) FROM ' . FREO_DATABASE_PREFIX . 'plugin_schedulereses WHERE schedule_id IN(' . implode(',', $plugin_schedule_all_keys) . ') GROUP BY schedule_id');
	if (!$stmt) {
		freo_error($freo->pdo->errorInfo());
	}

	while ($data = $stmt->fetch(PDO::FETCH_NUM)) {
		$scheduleres_counts[$data[0]] = 1 + $data[1];
	}


	//データ割当
	$freo->smarty->assign(array(
		'token'                 => freo_token('create'),
		'plugin_schedulereses'      => $plugin_schedulereses,
		'plugin_schedule_alls'      => $plugin_schedule_alls,
		'plugin_scheduleres_counts' => $scheduleres_counts
	));

	return;
}

?>
